#include "descriptor/descriptor.h"

int main(void)
{

ITEM bicchiere,bastone,ghiacciolo,miscelatore,ciotola,tavolino1,tavolino2,vassoio,drink1,drink2,drink3,drink4,oliva,ombrellino;
ITEM l_bicchieri,l_ghiaccio,l_tavolo,l_vassioio,l_oliva;
ITEM vetro,legno,ghiaccio,plastica,cotto,marmo,plastica2,liquido1,liquido2,liquido3,liquido4,olivastro,carta,muro,piastrelle;
ITEM parete, l_pareti1, l_pareti2, soffitto, pavimento;
ITEM scena;

//Sfondo: nessun colore definito per lo sfondo, lo sfondo non riflette
set_background(0,0,0,FALSE);

//Luce d'ambiente
set_ambient_light(1,1,1,0.8);

//Altre luci
create_distant_light(10,10,10,1,1,1,1,"lucina");

//Definizione degli attributi dei materiali
//
//Carta da parati
muro=create_attribute("materiale_muro");
set_color(muro,1,1,1,1,0);

//Pavimento
piastrelle=create_attribute("materiale_piastrelle");
set_color(piastrelle,1,1,1,1,0);

//Vetro per i bicchieri
vetro=create_attribute("materiale_vetro");
set_color(vetro,0.812,0.922,1,0.975,0.043);
set_reflectivity(vetro,0.040,2);
set_transparency(vetro,0.870,0.680,2,1.2);

//Legno per il supporto dell'obrellino
legno=create_attribute("materiale_legno");
set_color(legno,1,1,1,0.5,0.5);

//Ghiaccio per i ghiaccioli
ghiaccio=create_attribute("materiale_ghiaccio");
set_color(ghiaccio,0.72,1,1,0.940,0.266);
set_reflectivity(ghiaccio,0.240,2);
set_transparency(ghiaccio,0.870,0.680,1,1.2);

//Plastica per il miscelatore
plastica=create_attribute("materiale_plastica");
set_color(plastica,0.80,0,0.20,0.7,0.7);
set_reflectivity(plastica,0.5,1);

//Cotto per la ciotolina delle olive
cotto=create_attribute("materiale_cotto");
set_color(cotto,1,0.56,0.32,0.730,0.5);

//Marmo per il tavolino
marmo=create_attribute("materiale_marmobianco");
set_color(marmo,1,1,1,0.770,0.339);
set_reflectivity(marmo,0.150,0);

//Acciao per il vassoio
plastica2=create_attribute("materiale_plastica2");
set_color(plastica2,0.76,0.77,1,0.770,0.339);
set_reflectivity(plastica2,0.110,0);

//Liquidi contenuti nei bicchieri
liquido1=create_attribute("materiale_liquido1");
set_color(liquido1,0,0.66,1,0.490,0.303);
set_reflectivity(liquido1,0.060,1);
set_transparency(liquido1,0.770,0.400,1,0.183);


liquido2=create_attribute("materiale_liquido2");
set_color(liquido2,1,0,0,1,1);
set_reflectivity(liquido2,0.150,0);
set_transparency(liquido2,0.770,0.400,1,1.183);

liquido3=create_attribute("materiale_liquido3");
set_color(liquido3,1,1,0.42,1,1);
set_reflectivity(liquido3,0.150,0);//0.150,0.5
set_transparency(liquido3,0.770,0.400,1,1.183);

liquido4=create_attribute("materiale_liquido4");
set_color(liquido4,0.55,0.25,0,1,1);
set_reflectivity(liquido4,0.150,0);
set_transparency(liquido4,0.300,0.1,1,1.183);

//Materiale per le olive
olivastro=create_attribute("materiale_olivastro");
set_color(olivastro,0,0.54,0,0.750,0.275);
set_reflectivity(olivastro,0,0);


//Carta per l'ombrellino
carta=create_attribute("materiale_carta");
set_color(carta,1,0.50,0.80,1,1);

//Assegnazione dei materiali agli oggetti

//Bicchieri
bicchiere=read_nurbs("glass1.db");
l_bicchieri=create_list(bicchiere,"lista_bicchieri");
bicchiere=read_nurbs("glass2.db");
l_bicchieri=insert_in_list(l_bicchieri,bicchiere);
bicchiere=read_nurbs("glass3.db");
l_bicchieri=insert_in_list(l_bicchieri,bicchiere);
bicchiere=read_nurbs("glass4.db");
l_bicchieri=insert_in_list(l_bicchieri,bicchiere);
set_attribute(l_bicchieri,vetro);

scena=create_list(l_bicchieri,"scena");


//Bastone dell'ombrellino
bastone=read_nurbs("bastoncino.db");
//set_attribute(bastone,legno);
set_projection_texture(bastone,legno,"textures/legno.hr",1,1,1,1);


scena=insert_in_list(scena,bastone);

//ombrellino
ombrellino=read_nurbs("ombrellino.db");
set_attribute(ombrellino,carta);

scena=insert_in_list(scena,ombrellino);

//Cubetti di ghiaccio
ghiacciolo=read_nurbs("ghiaccio1.db");
l_ghiaccio=create_list(ghiacciolo,"lista_ghiaccio");
ghiacciolo=read_nurbs("ghiaccio2.db");
l_ghiaccio=insert_in_list(l_ghiaccio,ghiacciolo);
ghiacciolo=read_nurbs("ghiaccio3.db");
l_ghiaccio=insert_in_list(l_ghiaccio,ghiacciolo);
set_attribute(l_ghiaccio,ghiaccio);

scena=insert_in_list(scena,l_ghiaccio);

//Muri
parete=read_nurbs("parete_dx.db");
l_pareti1=create_list(parete,"lista_parete");
parete=read_nurbs("parete_sx.db");
l_pareti1=insert_in_list(l_pareti1,parete);

parete=read_nurbs("parete_centrale.db");
l_pareti2=create_list(parete,"lista_altra_parete");
parete=read_nurbs("parete_tmp.db");
l_pareti2=insert_in_list(l_pareti2,parete);

soffitto=read_nurbs("soffitto.db");

set_projection_texture(l_pareti1,muro,"textures/stucco.hr",0,1,1,1);
set_projection_texture(l_pareti2,muro,"textures/stucco.hr",1,1,1,1);
set_projection_texture(soffitto,muro,"textures/stucco.hr",2,1,1,1);


scena=insert_in_list(scena,l_pareti1);
scena=insert_in_list(scena,l_pareti2);
scena=insert_in_list(scena,soffitto);

//Miscelatore
miscelatore=read_nurbs("miscelatore.db");
set_attribute(miscelatore,plastica);

scena=insert_in_list(scena,miscelatore);

//Ciotolina porta olive
ciotola=read_nurbs("ciotola.db");
set_attribute(ciotola,cotto);

scena=insert_in_list(scena,ciotola);

//Tavolino
tavolino1=read_nurbs("tavolino.db");
set_projection_texture(tavolino1,marmo,"textures/marmo_rosa.hr",2,1,1,1);
tavolino2=read_nurbs("sostegno_tav.db");
set_projection_texture(tavolino2,marmo,"textures/marmo_rosa.hr",1,1,1,1);

scena=insert_in_list(scena,tavolino1);
scena=insert_in_list(scena,tavolino2);

//Pavimento
pavimento=read_nurbs("pavimento.db");
set_projection_texture(pavimento,piastrelle,"textures/cotto.hr",2,1,1,1);

scena=insert_in_list(scena,pavimento);

//Vassioio
vassoio=read_nurbs("plate.db");
set_attribute(vassoio,plastica2);

scena=insert_in_list(scena,vassoio);

//Olive
oliva=read_nurbs("oliva1.db");
l_oliva=create_list(oliva,"lista_oliva");
oliva=read_nurbs("oliva2.db");
l_oliva=insert_in_list(l_oliva,oliva);
oliva=read_nurbs("oliva3.db");
l_oliva=insert_in_list(l_oliva,oliva);
oliva=read_nurbs("oliva4.db");
l_oliva=insert_in_list(l_oliva,oliva);
oliva=read_nurbs("oliva5.db");
l_oliva=insert_in_list(l_oliva,oliva);
set_attribute(l_oliva,olivastro);

scena=insert_in_list(scena,l_oliva);


//Drink contenuti nei bicchieri
drink1=read_nurbs("drink1.db");
set_attribute(drink1,liquido1);

scena=insert_in_list(scena,drink1);

drink2=read_nurbs("drink2.db");
set_attribute(drink2,liquido2);

scena=insert_in_list(scena,drink2);

drink3=read_nurbs("drink3.db");
set_attribute(drink3,liquido3);

scena=insert_in_list(scena,drink3);

drink4=read_nurbs("drink4.db");
set_attribute(drink4,liquido4);

scena=insert_in_list(scena,drink4);

save_scene("bicchieri.md","scena",scena);

return(0);

}




